;************************
.nolist
#include "doorscs.inc"
_plotSScreen equ $8E29
_contrast equ $8008
_ClrScrn equ $4755
_runIndicOff equ 4795h
_curRow equ 800Ch
_CURCOL equ 800Dh
_penCol equ 8252h
_PENROW equ 8253h
_clrtxtshd equ $4755
Start equ $9327
NewPic equ SafeRAM1

#define bcall(xxxx) call xxxx
.list
;************************

.org Start

.db $aa
 jr ContinuePrg
.dw Des
.db $05,$00
.dw Hi
.dw $0000

Des:
.db "Super Saiya-jin Rage",0

Hi:
.db %00000000, %00000000
.db %00000000, %00000000
.db %00111000, %11101111
.db %01111101, %11100011
.db %01100001, %10000011
.db %01000001, %00000011
.db %01110001, %11000011
.db %00111000, %11100011
.db %00011000, %01100011
.db %00001100, %01100011
.db %00001100, %01100011
.db %00001100, %01101011
.db %00111000, %11101111
.db %01110001, %11000110
.db %00000000, %00000000
.db %00000000, %00000000

ContinuePrg:
 bcall(_cleargbuf)
 bcall(_runIndicOff)
 bcall(_ClrScrn)
 ld hl,TitlePic
 call SetUp
 jp ContProg
 
SetUp:
 ld de,NewPic
 call DspRLE
 ld hl,_plotSScreen
 ld de,NewPic
 
FadeIn:
 ld b,6
 xor a
 ld (Val),a
 push hl
 push de
Loop1:
 push bc
 ld b,128
Loop:
 ld a,(de)
 cp (hl)
 jr z,Fin
 ld a,1
 ld (Val),a
 inc (hl)
 ld a,(de)
 cp (hl)
 jr z,Fin
 inc (hl)
Fin:
 inc hl
 inc de
 djnz Loop
 pop bc
 djnz Loop1
 call iFastCopy
 pop de
 pop hl
 
 ld a,(Val)
 or a
 jr nz,FadeIn

FadeKey:
 call Pause
 
 ld hl,_plotSScreen
FadeOut:
 ld b,6
 xor a
 ld (Val),a
 push hl
Loop3:
 push bc
 ld b,128
Loop2:
 ld a,(hl)
 or a
 jr z,Fin2
 ld a,1
 ld (Val),a
 dec (hl)
 ld a,(hl)
 or a
 jr z,Fin2
 dec (hl)
Fin2:
 inc hl
 djnz Loop2
 pop bc
 djnz Loop3
 call iFastCopy
 pop hl
 ld a,(Val)
 jr nz,FadeOut
 ret
 
DspRLE:
 ld bc,768
DispRLEL:
 ld a,(hl)
 cp $91
 jr z,DispRLERun
 ldi
DispRLEC:
 ld a,b
 or c
 jr nz,DispRLEL
 ret
DispRLERun:
 inc hl
 ld a,(hl)
 inc hl
 push hl
 ld h,(hl)
 ex de,hl
DispRLERunL:
 ld (hl),a
 inc hl
 dec bc
 dec d
 jr nz,DispRLERunL
 ex de,hl
 pop hl
 inc hl
 jr DispRLEC

PauseGame:
 call Pause
 jp GameKeyLoop

Black_Band:
 bcall(_ClrScrn)
 ld hl,_plotSScreen+696
 ld de,_plotSScreen+697
 ld (hl),$FF
 ld bc,$47
 ldir
 jp iFastCopy

ShowBig:
 ld (_curRow),bc
 bcall(_PutS)
 ret
 
ShowSmall:
 ld (_penCol),bc
 bcall(_VPutS)
 ret
 
ContProg:
 bcall(_grbufclr)
 bcall(_clrlcdfull)
 ld hl,PlotsScreen
 ld bc,768
ContProgInvert:
 ld (hl),$ff
 inc hl
 dec bc
 ld a,c
 or b
 jr nz,ContProgInvert
 call _grbufcpy_v
 call InvText
 ld hl,stars
 ld bc,$0001
 call ShowBig
 ld hl,text
 inc c
 call ShowBig
 inc c
 call ShowBig
 ld hl,stars
 inc c
 call ShowBig
 ld hl,Menu
 ld bc,$3A00
 call ShowSmall
 ld c,$10
 call ShowSmall
 ld c,$2A
 call ShowSmall
 ld c,$3C
 call ShowSmall
 ld c,$50
 call ShowSmall
 call InvText

MainKeyLoop:
 bcall(_GetKey)
 cp 9
 jp z,EXIT
 cp 72
 jr z,Credits
 cp $2E
 jr z,Help
 cp 90
 jr z,About
 cp 68
 jp z,EXIT
 cp 73
 jp z,StartGame
 jr MainKeyLoop

Credits:
 call _grbufclr
 bcall(_ClrScrn)
 ld hl,people
 call InvText
 ld b,0
 ld c,b
 call ShowBig
 ld c,$05
 call ShowBig
 call InvText
 ld bc,$0A00
 call ShowSmall
 ld b,$12
 call ShowSmall
 ld b,$1A
 call ShowSmall
 ld b,$30
 call ShowSmall
 bcall(_GetKey)
 jp ContProg

Help:
 call _grbufclr
 bcall(_ClrScrn)
 ld hl,stuff
 call InvText
 ld b,0
 ld c,b
 call ShowBig
 call InvText
 ld b,$0D
 call ShowSmall
 ld b,$15
 call ShowSmall
 ld b,$1D
 call ShowSmall
 ld b,$25
 call ShowSmall
; ld b,$2D
; call ShowSmall
 bcall(_GetKey)
 jp ContProg

About:
 call _grbufclr
 bcall(_ClrScrn)
 ld hl,IntroText
 xor b
 xor c
 call ShowSmall
 ld b,$08
 call ShowSmall
 ld b,$10
 call ShowSmall
 ld b,$18
 call ShowSmall
 ld b,$20
 call ShowSmall
 call InvText
 ld b,$30
 call ShowSmall
 call InvText
 call Pause
 jp ContProg

InvText:
 bit 3,(iy+5)
 jr nz,ResText
 set 3,(iy+5)
 ret
ResText:
 res 3,(iy+5)
 ret

StartGame:
 bcall(_ClrScrn)
 bcall(_cleargbuf)
 bcall(_runIndicOff)
 ld a,1
 ld (play1_op),a
 ld (play2_op),a
 ld hl,Vegeta
 call LoadP1
 ld hl,Char1
 ld de,P_Op2
 ld bc,10
 ldir
 ld hl,Vegeta
 call LoadP2
 ld hl,Char1
 ld de,P_Op3
 ld bc,10
 ldir
 xor a
 ld de,$0B00
Difficulty_new:
 call DispA

Difficulty:
 call Show_POp2
 call Show_POp3
 call InvText
 call Show_POp1
 call InvText
Diff_2:
 bcall(_GetKey)
 cp 1
 jr z,IncDiff
 cp 2
 jr z,DecDiff
 cp 4
 jr z,Player1
 cp 5
 jp z,Really_Start
 cp 3
 jp z,Player2
 jr Diff_2
 
Show_POp2:
 ld hl,P_Op2
 ld bc,$0001
 jp ShowBig
 
Show_POp3:
 ld hl,P_Op3
 ld bc,$0002
 jp ShowBig

Show_POp1:
 ld hl,P_Op1
 ld bc,$0000
 jp ShowBig
 
IncDiff:
 ld a,(difficulty_mode)
 cp 2
 jr z,Difficulty
 inc a
 jr Set_Diff
 
DecDiff:
 ld a,(difficulty_mode)
 or a
 jr z,Difficulty
 dec a
Set_Diff:
 ld (difficulty_mode),a
 ld de,$0B00
 jr Difficulty_new
 
DispA:
 inc a
 ld l,a
 ld h,0
 xor a
 ld (_curRow),de
 bcall(_disphl)
 jp _VPutS
 
Load_POp2:
 ld de,P_Op2
 ldir
 
Player1:
 call Show_POp1
 call Show_POp3
 call InvText
 call Show_POp2
 call InvText
Play1_2:
 bcall(_GetKey)
 cp 3
 jp z,Difficulty
 cp 1
 jr z,IncPlay1
 cp 2
 jr z,DecPlay1
 cp 5
 jp z,Really_Start
 cp 4
 jp z,Player2
 cp $C1
 jp z,Cart1
 cp $B7
 jp z,Friz1
 cp $BB
 jp z,Buu1
 jr Play1_2
 
IncPlay1:
 ld a,(play1_op)
 cp 8
 jr z,Player1
 inc a
 ld (play1_op),a
 cp 8
 jp z,Got1
 jr Play1_1
 
DecPlay1:
 ld a,(play1_op)
 dec a
 jp z,Player1
 ld (play1_op),a
 dec a
 jr z,Vp1
Play1_1:
 dec a
 jr z,Gp1
 dec a
 jr z,G3p1
 dec a
 jr z,Hp1
 dec a
 jp z,Tp1
 dec a
 jp z,Raditz1
 dec a
 jp z,GGtp1
 jp Player1
 
Got1:
 call Clear_Char1
 ld hl,Gotenks
 call LoadP1
 ld hl,Gotnk
 ld bc,7
 jp Load_POp2
 
Vp1:
 call Clear_Char1
 ld hl,Vegeta
 call LoadP1
 ld hl,Char1
 ld bc,10
 jp Load_POp2
 
GGtp1:
 call Clear_Char1
 ld hl,GokuGT
 call LoadP1
 ld hl,GGtText
 ld bc,13
 jp Load_POp2
 
Friz1:
 call Clear_Char1
 ld hl,Frieza
 call LoadP1
 ld hl,CharF
 ld bc,6
 jp Load_POp2
 
Gp1:
 call Clear_Char1
 ld hl,Kakarot
 call LoadP1
 ld hl,Char2
 ld bc,8
 jp Load_POp2

G3p1:
 call Clear_Char1
 ld hl,SSJ3_Goku
 call LoadP1
 ld hl,Char4
 ld bc,10
 jp Load_POp2
 
Hp1:
 call Clear_Char1
 ld hl,Gohan
 call LoadP1
 ld hl,Char5
 ld bc,9
 jp Load_POp2

Tp1:
 call Clear_Char1
 ld hl,Trunks
 call LoadP1
 ld hl,Char6
 ld bc,10
 jp Load_POp2
 
Cart1:
 call Clear_Char1
 ld hl,cartman
 call LoadP1
 ld hl,Cart
 ld bc,12
 jp Load_POp2
 
Raditz1:
 call Clear_Char1
 ld hl,Raditz
 call LoadP1
 ld hl,Rad
 ld bc,6
 jp Load_POp2

Buu1:
 call Clear_Char1
 ld hl,Buu
 call LoadP1
 ld hl,Majin
 ld bc,9
 jp Load_POp2
 
LoadP1:
 ld de,play1
 ld bc,56
 ldir
 ld hl,CleanChar
 ld de,P_Op2
 ld bc,13
 ldir
Clear_Char1:
 xor b
 ld c,$24
 ld ix,play1
 call PutSprite
 jp iFastCopy
 
Load_POp3:
 ld de,P_Op3
 ldir
 
Player2:
 call Show_POp2
 call Show_POp1
 call InvText
 call Show_POp3
 call InvText
Play2_2:
 bcall(_GetKey)
 cp 3
 jp z,Player1
 cp 1
 jr z,IncPlay2
 cp 2
 jr z,DecPlay2
 cp 4
 jp z,Difficulty
 cp $B7
 jp z,Friz2
 cp 5
 jp z,Really_Start
 cp $C1
 jp z,Cart2
 cp $BB
 jp z,Buu2
 jr Play2_2
 
IncPlay2:
 ld a,(play2_op)
 cp 8
 jr z,Player2
 inc a
 ld (play2_op),a
 cp 8
 jr z,Got2
 jr Play2_1

DecPlay2:
 ld a,(play2_op)
 cp 1
 jr z,Player2
 dec a
 ld (play2_op),a
 cp 1
 jr z,Vp2
Play2_1:
 cp 2
 jr z,Gp2
 cp 4
 jp z,Hp2
 cp 3
 jr z,G3p2
 cp 5
 jp z,Tp2
 cp 6
 jr z,GGtp2
 cp 7
 jp z,Raditz2
 jp Player2
 
Got2:
 call Clear_Char2
 ld hl,Gotenks
 call LoadP2
 ld hl,Gotnk
 ld bc,7
 jp Load_POp3
 
GGtp2:
 call Clear_Char2
 ld hl,GokuGT
 call LoadP2
 ld hl,GGtText
 ld bc,13
 jp Load_POp3
 
Friz2:
 call Clear_Char2
 ld hl,Frieza
 call LoadP2
 ld hl,CharF
 ld bc,6
 jp Load_POp3
 
Vp2:
 call Clear_Char2
 ld hl,Vegeta
 call LoadP2
 ld hl,Char1
 ld bc,10
 jp Load_POp3
 
Gp2:
 call Clear_Char2
 ld hl,Kakarot
 call LoadP2
 ld hl,Char2
 ld bc,8
 jp Load_POp3

Cart2:
 call Clear_Char2
 ld hl,cartman
 call LoadP2
 ld hl,Cart
 ld bc,12
 jp Load_POp3

G3p2:
 call Clear_Char2
 ld hl,SSJ3_Goku
 call LoadP2
 ld hl,Char4
 ld bc,10
 jp Load_POp3
 
Hp2:
 call Clear_Char2
 ld hl,Gohan
 call LoadP2
 ld hl,Char5
 ld bc,9
 jp Load_POp3

Tp2:
 call Clear_Char2
 ld hl,Trunks
 call LoadP2
 ld hl,Char6
 ld bc,10
 jp Load_POp3
 
Raditz2:
 call Clear_Char2
 ld hl,Raditz
 call LoadP2
 ld hl,Rad
 ld bc,6
 jp Load_POp3

Buu2:
 call Clear_Char2
 ld hl,Buu
 call LoadP2
 ld hl,Majin
 ld bc,9
 jp Load_POp3
 
LoadP2:
 ld de,play2
 ld bc,56
 ldir
 ld hl,play2
 ld b,56
 call Reverse_Sprite
 ld ix,play2
 ld b,28
 call Rev16
 ld hl,CleanChar
 ld de,P_Op3
 ld bc,13
 ldir
Clear_Char2:
 ld bc,$5024
 ld ix,play2
 call PutSprite
 jp iFastCopy
 
Reverse_Sprite:
 ld c,(hl)
 call FixC2
 call FixC2
 call FixC2
 call FixC2
 ld (hl),a
 inc hl
 djnz Reverse_Sprite
 ret

FixC2:
 rlc c
 rra
 rlc c
 rra
 ret

Rev16:
 ld d,(ix)
 ld e,(ix+1)
 ld (ix),e
 ld (ix+1),d
 inc ix
 inc ix
 djnz Rev16
 ret
 
Really_Start:
 bcall(_ClrScrn)
 bcall(_cleargbuf)
 call Black_Band
 ld bc,$0505
 ld (Vegetaxy),bc
 ld (VegetaxyOld),bc
 ld ix,play1
 call PutSprite
 xor a
 ld (IsFire),a
 ld bc,$4F05
 ld (Kakarotxy),bc
 ld (KakarotxyOld),bc
 ld ix,play2
 call PutSprite
 xor a
 ld (IsFireG),a
 ld a,30
 ld (VegetaP),a
 ld a,65
 ld (KakarotP),a
 xor a
 ld (Kakarot_counter),a

GameKeyLoop:
 ld a,(difficulty_mode)
 ld b,a
 or a
 jr z,very_hard_mode
diffloop:
 halt
 djnz diffloop
very_hard_mode:
 bcall(_getcsc)
 ld a,126
 out (1),a
 in a,(1)
 bit 3,a
 push af
 call z,MoveUP
 pop af
 bit 2,a
 push af
 call z,MoveRIGHT
 pop af
 bit 1,a
 push af
 call z,MoveLEFT
 pop af
 bit 0,a
 call z,MoveDOWN
 ld a,63
 out (1),a
 in a,(1)
 bit 5,a
 push af
 call z,Fire
 pop af
 bit 7,a
 jp z,PauseGame
 bit 6,a
 call z,EXIT
 call iFastCopy
 call moveFireball

Moves_Kakarot_Randomly:
 ld a,(difficulty_mode)
 ld b,a
 or a
 jr z,very_hard_mode2
diffloop2:
 halt
 djnz diffloop2
very_hard_mode2:
 call KakarotFIRES
 ld a,(Kakarot_counter)
 or a
 jr z,new_direction
 ld a,(Kakarot_direction)
 cp 1
 call z,MoveKakarotLeft
 ld a,(Kakarot_direction)
 cp 2
 call z,MoveKakarotRight
 ld a,(Kakarot_direction)
 cp 3
 call z,MoveKakarotUp
 ld a,(Kakarot_direction)
 cp 4
 call z,MoveKakarotDown
 ld hl,Kakarot_counter
 dec (hl)
 jp GameKeyLoop
new_direction:
 ld a,r
 and 3
 inc a
 ld (Kakarot_direction),a
 ld a,10
 ld (Kakarot_counter),a
 jp GameKeyLoop

KakarotFIRES:
 call FireG
 jp moveFireballG

Collision_DetectionG:
 ld a,(Vegetaxy)
 ld b,a
 ld a,(FireGxy)
 sub b
 cp 23
 ret nc
 ld a,(Vegetaxy+1)
 ld b,a
 ld a,(FireGxy+1)
 sub b
 sub 13
 cp 3
 ret nc
 ld a,(VegetaP)
 ld d,61
 ld e,a
 call FindPixel
 cpl
 and (hl)
 ld (hl),a
 inc e
 inc d
 call FindPixel
 cpl
 and (hl)
 ld (hl),a
 inc d
 dec e
 call FindPixel
 cpl
 and (hl)
 ld (hl),a
 ld hl,VegetaP
 dec (hl)
 ld a,(hl)
 or a
 ret nz
 pop bc
 pop bc
 pop bc
 jp ContinuePrg

Collision_Detection:
 ld a,(Kakarotxy)
 ld b,a
 ld a,(Firexy)
 sub b
 cp 23
 ret nc
 ld a,(Kakarotxy+1)
 ld b, a
 ld a,(Firexy+1)
 add a,16
 sub b
 cp 3
 ret nc
 ld a,(KakarotP)
 ld d,61
 ld e,a
 call FindPixel
 cpl
 and (hl)
 ld (hl),a
 dec e
 inc d
 call FindPixel
 cpl
 and (hl)
 ld (hl),a
 inc d
 inc e
 call FindPixel
 cpl
 and (hl)
 ld (hl),a
 ld hl,KakarotP
 inc (hl)
 ld a,(hl)
 cp 96
 ret nz
 pop bc
 pop bc
 pop bc
 jp Winner

FindPixel:
 ld a,e
 ld e,d
 jp iGetPixel
 
random:
 ld b,2
 ld a,r
 add a,$10
_seed = $-1
 sub b
 push af
 ld a,(_seed)
 ld c,a
 pop af
 ld (_seed),a
 add a,c
 and b
 ret

PutIt:
 ld a,b
 ld l,c
 ld bc,$0502
 jp iLargeSprite
 
PutSprite:
 ld a,b
 ld l,c
 ld bc,$1C02
 jp iLargeSprite
 
MoveKakarotUp:
 ld bc,(Kakarotxy)
 dec c
 ld a,c
 cp 255
 ret z
 ld (Kakarotxy),bc
 jp moveKakarot

MoveKakarotDown:
 ld bc,(Kakarotxy)
 inc c
 ld a,c
 cp 31
 ret nc
 ld (Kakarotxy),bc
 jp moveKakarot

MoveKakarotRight:
 ld bc,(Kakarotxy)
 inc b
 ld a,b
 cp $50
 ret z
 ld (Kakarotxy),bc
 jp moveKakarot
 
MoveKakarotLeft:
 ld bc,(Kakarotxy)
 dec b
 ld a,b
 cp $30
 ret z
 ld (Kakarotxy),bc

moveKakarot:
 ld bc,(KakarotxyOld)
 ld ix,play2
 call PutSprite
 ld bc,(Kakarotxy)
 ld (KakarotxyOld),bc
 ld ix,play2
 jp PutSprite
 
MoveRIGHT:
 ld bc,(Vegetaxy)
 inc b
 ld a,b
 cp $20
 ret z
 ld (Vegetaxy),bc
 jr moveVegeta

MoveUP:
 ld bc,(Vegetaxy)
 dec c
 ld a,c
 cp 255
 ret z
 ld (Vegetaxy),bc
 jr moveVegeta

MoveDOWN:
 ld bc,(Vegetaxy)
 inc c
 ld a,c
 cp 31
 ret nc
 ld (Vegetaxy),bc
 jr moveVegeta

MoveLEFT:
 ld bc,(Vegetaxy)
 dec b
 ld a,b
 or a
 ret z
 ld (Vegetaxy),bc

moveVegeta:
 ld bc,(VegetaxyOld)
 ld ix,play1
 call PutSprite
 ld bc,(Vegetaxy)
 ld (VegetaxyOld),bc
 ld ix,play1
 jp PutSprite
 
Fire:
 ld hl,IsFire
 xor a
 cp (hl)
 ret nz
 ld (hl),1
 ld hl,(Vegetaxy)
 ld de,$0811
 add hl,de
 ld b,h
 ld c,l
 ld (Firexy),bc
 ld (FirexyOld),bc
 ld ix,Fireball
 jp PutIt

FireG:
 ld hl,IsFireG
 xor a
 cp (hl)
 ret nz
 ld (hl),1
 ld hl,(Kakarotxy)
 ld a,l
 add a,11
 ld c,a
 ld a,h
 sub 8
 ld b,a
 ld (FireGxy),bc
 ld (FireGxyOld),bc
 ld ix,Fireball2
 jp PutIt

moveFireball:
 ld hl,IsFire
 xor a
 cp (hl)
 ret z
 ld bc,(Firexy)
 inc b
 inc b
 ld a,79
 cp b
 jr c,fire_hit_wall
 ld (Firexy),bc
 push bc
 call Collision_Detection
 ld bc,(FirexyOld)
 ld ix,Fireball
 push ix
 call PutIt
 pop ix
 pop bc
 ld (FirexyOld),bc
 jp PutIt

moveFireballG:
 ld hl,IsFireG
 xor a
 cp (hl)
 ret z
 ld bc,(FireGxy)
 dec b
 dec b
 ld a,1
 cp b
 jr nc,fire_hit_wallG
 ld (FireGxy),bc
 push bc
 call Collision_DetectionG
 ld bc,(FireGxyOld)
 ld ix,Fireball2
 push ix
 call PutIt
 pop ix
 pop bc
 ld (FireGxyOld),bc
 jp PutIt

fire_hit_wall:
 ld bc,(FirexyOld)
 ld ix,Fireball
 call PutIt
 xor a
 ld (IsFire),a
 ret

fire_hit_wallG:
 ld bc,(FireGxyOld)
 ld ix,Fireball2
 call PutIt
 xor a
 ld (IsFireG),a
 ret

Winner:
 bcall(_cleargbuf)
 bcall(_ClrScrn)
 ld hl,WinPic
 call SetUp
 call Pause
 jp ContProg
 
EXIT:
 bcall(_ClrScrn)
 res 3,(iy+35)
 ret
 
#include "data96.asm"

end